
//******************************************************************************
//  MSP-FET430P140 Demo 
//
//  Built with CCE Version: 3.2.0 and IAR Embedded Workbench Version: 3.21A
//******************************************************************************

#include  <msp430f1132.h>
#include  <intrinsics.h>
#include "LCD_Nokia_1202.h"


float C_float,U_float,k_A,k_B;
unsigned long s1,s2,s3,s4,s5,s6,s7,s8,s9;
volatile unsigned long A0,A1,AC0,AC1,AC2,AC4,AC3;
volatile unsigned int INCH;
char pr_start,x,rejim; //   
int N_izm,i,N_perep,N_perep_2,N_imp;


const float a[13]={  14.0,       198.0,       5402.0,     7694.0,  17710.0,   32723.0, 157678.0, 663310.0, 860268.0,  1150050.0, 1181490.0, 1200700.0, 1203040.0}; 
const float b[13]={  97000000.0, 8200000.0,   286400.0,  200000.0, 86400.0,   46000.0,   8325.0,   1000.0,     487.0,     56.0,      22.0,       2.2,      0.0}; 

const float c[10]={  80.0,       680.0,   4680.0,   9978.0,    22700.0, 44176.0,83340.0,  291100.0, 667420.0,779600.0}; 
const float d[10]={  6000000.0, 679000.0,   99100.0,   46100.0, 20000.0,  10000.0,  5010.0,     998.0,  102.0 ,   0.0}; 


void main(void)
{
  unsigned int i;
  WDTCTL = WDT_ADLY_1000;                     // SMKCLK / 32768, interval timer 2.7 Hz
  BCSCTL1 |= XTS+DIVA_3;                           // ACLK = LFXT1 = HF XTAL
  
  ADC10CTL1 = INCH_2;                      // AVcc/2
  
  ADC10CTL0 = ADC10SHT_2 + ADC10ON + REFON +REF2_5V; // ADC10ON, interrupt enabled
  ADC10AE |= BIT2;                          // P2.0 ADC option select
  
  
  do
  {
  IFG1 &= ~OFIFG;                           // Clear OSCFault flag
  for (i = 0xFF; i > 0; i--);               // Time for flag to set
  }
  while ((IFG1 & OFIFG));                   // OSCFault flag still set?
  
  IE1 |= WDTIE;                             // Enable WDT interrupt 
  BCSCTL2 |= SELM_3;                        // MCLK = LFXT1 (safe) 

  
//    
  P1DIR |= BIT0;   // P1.0= CS 
  P1DIR |= BIT1;   // P1.1 SDA  
  P1DIR |= BIT2;   // P1.2 CLK
              
  P1OUT &=~ BIT0;    // P1.0= CS                        
  P1OUT &=~ BIT1;    // P1.1 SDA                       
  P1OUT &=~ BIT2;    // P1.2 CLK                       
//    
 
    P2SEL |= BIT1; 

//    P2DIR |= BIT3;   // P2.3          
//    P2OUT |= BIT3;   //      
    
    P2DIR |= BIT4;   // P2.4 R   
    P1DIR |= BIT3;   // P1.3  
    
         P2OUT |= BIT4;     //  R                      
         P1OUT &=~ BIT3;    //  C    
    rejim=1;
    
    
//    
  CCTL0 = CCIE;                             // CCR0 interrupt enabled
  CCR0 = 65500;
  TACTL = TASSEL_3 + MC_0;                  // INCLK, stop
//    

  _BIS_SR(GIE);                 // Enter LPM0 w/ interrupt
  
LCD_INIT();
LCD_CLR();

pr_start=0;
N_perep=0;

  // Mainloop
  for (;;)
  {
    ADC10CTL0 |= ENC + ADC10SC;             // Sampling and conversion start
U_float=ADC10MEM*0.06454;

if ((P2IN & BIT0)==0) 
     {
       rejim++;
       if (rejim>1) rejim=0;
       if (rejim==0) 
        {
          LCD_CLR();
          P2OUT &=~ BIT4;    // P2.4   R                      
          P1OUT |=  BIT3;    // P1.3   C  
        };
       if (rejim==1) 
       {
         LCD_CLR();
         P2OUT |= BIT4;     //  R                      
         P1OUT &=~ BIT3;    //  C    
       };
       __delay_cycles(3000000);  //  1    DCO 750 
     };
  
//  __delay_cycles(600000);  //  0.5    DCO 750 

  }
  
}


// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  N_perep++;
}


// Watchdog Timer interrupt service routine
#pragma vector=WDT_VECTOR
__interrupt void watchdog_timer(void)
{
  N_imp++;

  
if (pr_start==0)
 {
    TACTL = TASSEL_3 + MC_1;                  // INCLK, start
    N_perep=0;
    TAR=0;
    pr_start=1;
 };
  
if ( (pr_start==1)&& (N_imp==25))
 {
    TACTL = TASSEL_3 + MC_0;                  // INCLK, stop
//    P2OUT ^= BIT3;    // P1.0= CS   
    N_imp=0;
    pr_start=0;

s1=U_float/10;
s2=U_float-s1*10;
LCD_POS(0,70);
LCD_CHAR(s1);
LCD_CHAR(11); // .
LCD_CHAR(s2);    
LCD_CHAR(26);  
    
    AC1=(TAR+65500*N_perep);
    AC1=AC1/1.04475136; 
    N_perep=0;

s1=AC1/100000000;
s2=(AC1-s1*100000000)/10000000;
s3=(AC1-s1*100000000-s2*10000000)/1000000; 
s4=(AC1-s1*100000000-s2*10000000-s3*1000000)/100000; 
s5=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000)/10000; 
s6=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000)/1000; 
s7=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000)/100; 
s8=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000-s7*100)/10; 
s9=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000-s7*100-s8*10); 

LCD_POS(7,0);
LCD_CHAR(s1);
LCD_CHAR(s2);
LCD_CHAR(s3);
LCD_CHAR(11); // .
LCD_CHAR(s4);
LCD_CHAR(s5);
LCD_CHAR(s6);
LCD_CHAR(11); // .
LCD_CHAR(s7);
LCD_CHAR(s8);
LCD_CHAR(s9);


if (rejim==0)
{
LCD_POS(2,24);
LCD_CHAR(17);  // 
LCD_CHAR(18);  // 
LCD_CHAR(19);  // 
LCD_CHAR(20); // 
LCD_CHAR(21);  // c
LCD_CHAR(10);  // 
LCD_CHAR(12);  // 

  if (AC1>=a[12]) AC1=a[12]; // 8500000 480000

for (x=0;x<12;x++)
{
  //               y=ax+b
  if ((AC1>=a[x])&&(AC1<=a[x+1])) // 8500000 480000
  {
    k_A=(b[x]-b[x+1])/(a[x+1]-a[x]);
    k_B=b[x+1]+k_A*a[x+1];
    C_float=k_B-k_A*AC1;  
  };
};

if ((C_float>1000.0)&&((C_float/10.0)<=99999.0))
{
  AC0=C_float/100.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 

  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
  LCD_CHAR_12x16 (4, 70, 15);
  LCD_CHAR_12x16 (4, 82, 14);    
};

if ((C_float/10.0)>99999.0)
{
  AC0=C_float/100000.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 

  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
  LCD_CHAR_12x16 (4, 70, 16);
  LCD_CHAR_12x16 (4, 82, 14);    
};

if (C_float<1000.0) 
{
  AC0=C_float*10.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 
  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
  LCD_CHAR_12x16 (4, 70, 13);
  LCD_CHAR_12x16 (4, 82, 14);    
};

}; //   

if (rejim==1)
{

LCD_POS(2,14);
LCD_CHAR(22);  // C
LCD_CHAR(20);  // 
LCD_CHAR(23);  // 
LCD_CHAR(24);  // 
LCD_CHAR(20);  // 
LCD_CHAR(10);  // 
LCD_CHAR(25);  // 
LCD_CHAR(26); // 
LCD_CHAR(27); // 
LCD_CHAR(28); // 
LCD_CHAR(29); // 
LCD_CHAR(25); // 
LCD_CHAR(28); // 


  if (AC1>=c[9]) AC1=c[9]; // 8500000 480000
  if (AC1<=10) AC1=c[0]; // 8500000 480000
for (x=0;x<9;x++)
{
  if ((AC1>=c[x])&&(AC1<=c[x+1])) // 8500000 480000
  {
    k_A=(d[x]-d[x+1])/(c[x+1]-c[x]);
    k_B=d[x+1]+k_A*c[x+1];
    C_float=k_B-k_A*AC1;  
  };
};

if ((C_float>1000.0)&&((C_float/10.0)<=99999.0))
{
  AC0=C_float/100.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 

  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
LCD_CHAR(32); // sp  
LCD_CHAR(19); // 
LCD_CHAR(30); // 
LCD_CHAR(18); //     
//  LCD_CHAR_12x16 (4, 70, 15);
//  LCD_CHAR_12x16 (4, 82, 14);    
};

if ((C_float/10.0)>99999.0)
{
  AC0=C_float/100000.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 

  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
  LCD_CHAR(32); // sp  
LCD_CHAR(31); // 
LCD_CHAR(30); // 
LCD_CHAR(18); //   
//  LCD_CHAR_12x16 (4, 70, 16);
//  LCD_CHAR_12x16 (4, 82, 14);    
};

if (C_float<1000.0) 
{
  AC0=C_float*10.0;
  s1=AC0/1000;
  s2=(AC0-s1*1000)/100;
  s3=(AC0-s1*1000-s2*100)/10; 
  s4=(AC0-s1*1000-s2*100-s3*10)/1; 
  LCD_CHAR_12x16 (4, 10, s1);
  LCD_CHAR_12x16 (4, 22, s2);
  LCD_CHAR_12x16 (4, 34, s3);
  LCD_CHAR_12x16 (4, 46, 11);
  LCD_CHAR_12x16 (4, 58, s4);  
  LCD_CHAR(32); // sp  
  LCD_CHAR(32); // sp  
LCD_CHAR(30); // 
LCD_CHAR(18); //     
//  LCD_CHAR_12x16 (4, 70, 13);
//  LCD_CHAR_12x16 (4, 82, 14);    
};
}; //   

 };
}





////******************************************************************************
////  MSP-FET430P140 Demo 
////
////  Built with CCE Version: 3.2.0 and IAR Embedded Workbench Version: 3.21A
////******************************************************************************
//
//#include  <msp430f1132.h>
//#include  <intrinsics.h>
//#include "LCD_Nokia_1202.h"
//
//
//float C_float,k_A,k_B;
//int x;
//unsigned long s1,s2,s3,s4,s5,s6,s7,s8,s9;
//volatile long long A0,A1,AC2,AC1,N_imp,N_perep;
//volatile unsigned int INCH;
//char start,stop; //   
//int N_izm,i,N_perep_2;
//const long a[16]={121,    1988, 7100,  10900,16000, 20460, 31195,39705,77850,214344,230670,266670,341100,353100,358500,361810}; 
//const long b[16]={8500000,480000,116000,86000,58000,44100,27800, 21500,9700,  1775,  1504,  980,  215,    98,   58,    0}; 
//
//void main(void)
//{
//  unsigned int i;
//  WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT
//  BCSCTL1 |= XTS;                           // ACLK = LFXT1 = HF XTAL
//  do
//  {
//  IFG1 &= ~OFIFG;                           // Clear OSCFault flag
//  for (i = 0xFF; i > 0; i--);               // Time for flag to set
//  }
//  while ((IFG1 & OFIFG));                   // OSCFault flag still set?
//
//  BCSCTL2 |= SELM_3;                        // MCLK = LFXT1 (safe) 
//
//  
////    
//  P1DIR |= BIT0;   // P1.0= CS 
//  P1DIR |= BIT1;   // P1.1 SDA  
//  P1DIR |= BIT2;   // P1.2 CLK
//              
//  P1OUT &=~ BIT0;    // P1.0= CS                        
//  P1OUT &=~ BIT1;    // P1.1 SDA                       
//  P1OUT &=~ BIT2;    // P1.2 CLK                       
////    
//
//    P2DIR |= BIT4;   // P2.4 R   
//    P1DIR |= BIT3;   // P1.3  
//    
//    P2OUT |= BIT4;    // P2.4      R                      
//    P1OUT &=~ BIT3;    // P1.3    
//    
// //  P2SEL |= BIT3;
//   
////         
//  P2IE |= BIT3;                         // P2.0 interrupt enabled
//  P2IES |= BIT3;                        // P2.0 Hi/lo edge
//  P2IFG &=~ BIT3;                       // P2.0 IFG cleared
////          
//  
////    
//  TACCTL0 = CCIE;                             //     CCR0 interrupt enabled
//  TACCTL1 = CM1 + CCIS_1 + CAP + CCIE;     //    ,   CCI1B,   ,  interrupt enabled  
//  CCR0 = 50000;
//  TACTL = TASSEL_1 + MC_1;                  // ACLK, contmode
////    
//
//  _BIS_SR(GIE);                 // Enter LPM0 w/ interrupt
//  
//LCD_INIT();
//LCD_CLR();
////
////  LCD_CHAR_12x16 (6, 50, 15);
////  LCD_CHAR_12x16 (6, 70, 14);  
//
//
//  // Mainloop
//  for (;;)
//  {
//N_imp=0;
//TAR=0;
//N_perep=0;
//__delay_cycles(3000000);  //  1    DCO 750 
//AC1=N_imp; //*50000+CCR1;
//AC2=N_perep*50000+CCR1;
//
////s1=AC1/100000000;
////s2=(AC1-s1*100000000)/10000000;
////s3=(AC1-s1*100000000-s2*10000000)/1000000; 
////s4=(AC1-s1*100000000-s2*10000000-s3*1000000)/100000; 
////s5=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000)/10000; 
////s6=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000)/1000; 
////s7=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000)/100; 
////s8=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000-s7*100)/10; 
////s9=(AC1-s1*100000000-s2*10000000-s3*1000000-s4*100000-s5*10000-s6*1000-s7*100-s8*10); 
////
////
////LCD_POS(0,0);
////LCD_CHAR(s1);
////LCD_CHAR(s2);
////LCD_CHAR(s3);
////LCD_CHAR(11); // .
////LCD_CHAR(s4);
////LCD_CHAR(s5);
////LCD_CHAR(s6);
////LCD_CHAR(11); // .
////LCD_CHAR(s7);
////LCD_CHAR(s8);
////LCD_CHAR(s9);
//  }
//  
//}
//
//
//
//// Timer_A3 Interrupt Vector (TAIV) handler
//#pragma vector=TIMERA1_VECTOR
//__interrupt void Timer_A(void)
//{
//  switch( TAIV )
//  {
//  case  2:                                  // CCR1
//    {
//     N_imp++;                   // Timer_A3 overflow
//    }
//           break;
//  case  4: break;                           // CCR2 not used
//  case 10:     
//    {
//     N_perep++;                   // Timer_A3 overflow
//    }
//           break;                          // overflow 
// }
//}
//
//// Port 2 interrupt service routine
//#pragma vector=PORT2_VECTOR
//__interrupt void Port_2(void)
//{
//
//P2IFG &= ~BIT0;                       // P2.1 IFG clearedf
//}

